﻿#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"

using namespace DuiLib;
class CSMSSendWnd;

struct SmsSearchItemInfo
{	
	bool empty;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString tel;
};

#define MSG_CLOSE_SMS_SEARCH (WM_USER + 9941)
#define MSG_CLOSE_RECENT_CONTACT (WM_USER + 9942)

class CSmsSearchWnd : public WindowImplBase
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CSmsSearchWnd(CSMSSendWnd *pChatDlg);
	~CSmsSearchWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();

	void SetRectInParent(CRect rc);
	CRect GetRectInParent(){return m_rcClient;};
	int  GetChatSearchHeight();
	HWND GetSafeHwnd(){return m_hWnd;}
	CListUI* GetFriendsCtrl();
	CLabelUI* GetNosearchResultLabel();
	std::vector<CString> GetListUserID();
	Node* GetRootNode(){return root_node_;};
	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	//bool Add(CControlUI* pControl);
	bool AddAt(CControlUI* pControl, int iIndex);
	bool RemoveAt(int iIndex);
	void RemoveAll();
	Node* AddNode(const SmsSearchItemInfo& item,const NE_MEMBER_DATA* pMembereData, 	GTUserStatusType status, int nCompareData, Node* parent = NULL, int nTopPadding = 0);
	bool RemoveNode(Node* node);
	void  UpdateSearchWndMember(const std::vector<ORG_MEMBER_DATA> &memberVector);
	Node* FindNode(Node* node,CString usrID);
	void SetSearchHeight(int nHeight, BOOL bResize);
	int GetSearchHeight();
	void UpdateAddBtnAndTooltip(CString strID,CString strTel);

public:
	std::vector<SmsSearchItemInfo> m_vecfriend;
	
private:
    void _OnNotifyPrepare(TNotifyUI& msg);
 //   void _OnNotifyItemClick(TNotifyUI& msg);
    void _OnCtrlChatAddBtnClick(TNotifyUI& msg);

    void _OnMsgSysKeyDown(TNotifyUI& msg);//(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    void _OnMsgSize(TNotifyUI& msg);//(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgActiveParent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgInactiveHide(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	 LRESULT OnMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:
	int m_nSmsSearchWndHeight;
	CRect m_rcClient;
	SmsSearchItemInfo m_friendListInfo;
	CSMSSendWnd *m_pSmsSendWnd;

	CDialogBuilder m_dlgBuilder;
	Node*	root_node_;	
	CDuiRect	text_padding_;
	int level_text_start_pos_;
};

class CSmsRecentContactWnd : public WindowImplBase
{
	DUI_DECLARE_MESSAGE_MAP()
	DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CSmsRecentContactWnd(CSMSSendWnd *pDlg);
	~CSmsRecentContactWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();

	void SetRectInParent(CRect rc);
	CRect GetRectInParent(){return m_rcClient;};
	int  GetChatSearchHeight();
	HWND GetSafeHwnd(){return m_hWnd;}
	CListUI* GetFriendsCtrl();

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	bool AddAt(CControlUI* pControl, int iIndex);
	bool RemoveAt(int iIndex);
	void RemoveAll();
	Node* AddNode(const SmsSearchItemInfo& item, int nCompareData, Node* parent = NULL, int nTopPadding = 0);
	bool RemoveNode(Node* node);
	void SetHeight(int nHeight, BOOL bResize);
	int GetHeight();
public:
	std::vector<SmsSearchItemInfo> m_vecfriend;

private:
	void _OnNotifyPrepare(TNotifyUI& msg);
	void _OnNotifyItemClick(TNotifyUI& msg);
	void _OnCtrlChatAddBtnClick(TNotifyUI& msg);

	void _OnMsgSysKeyDown(TNotifyUI& msg);//(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT _OnMsgActiveParent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT _OnMsgInactiveHide(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void LoadRecentContact();
	LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:
	int m_nWndHeight;
	CRect m_rcClient;
	SmsSearchItemInfo m_friendListInfo;
	CSMSSendWnd *m_pSmsSendWnd;

	CDialogBuilder m_dlgBuilder;
	Node*	root_node_;
	
	CDuiRect	text_padding_;
	
};
